(* Copyright (C) 2009 Free Software Foundation, Inc. *)
(* This file is part of GNU Modula-2.

GNU Modula-2 is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation; either version 2, or (at your option) any later
version.

GNU Modula-2 is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with gm2; see the file COPYING.  If not, write to the Free Software
Foundation, 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA. *)

MODULE longreal ;

FROM StringConvert IMPORT LongrealToString ;
FROM DynamicStrings IMPORT String, EqualArray, string ;
FROM libc IMPORT exit, printf ;


PROCEDURE Assert (b: BOOLEAN; l: CARDINAL) ;
BEGIN
   IF NOT b
   THEN
      printf("%s:%d:regression test failed during execution\n",
              __FILE__, l) ;
      exit(1)
   END
END Assert ;


VAR
   s: String ;
   r: REAL ;
   l: LONGREAL ;
BEGIN
   r := 0.0123 ;
   s := LongrealToString(r, 8, 8) ;
   Assert(EqualArray(s, '0.012300'), __LINE__) ;
   printf("printf converting 0.0123 = %g\n", r);
   printf("result should be 0.012300 = %s\n", string(s)) ;
   l := 0.0123 ;
   s := LongrealToString(l, 8, 8) ;
   printf("result should be 0.012300 = %s\n", string(s)) ;
   Assert(EqualArray(s, '0.012300'), __LINE__) ;
   s := LongrealToString(0.0123, 8, 8) ;
   Assert(EqualArray(s, '0.012300'), __LINE__) ;
   printf("result should be 0.012300 = %s\n", string(s)) ;
   Assert(EqualArray(s, '0.012300'), __LINE__) ;
END longreal.
